//***************************************************************************
//
//  Rupllib.c
//
//***************************************************************************

#include <windows.h>

__declspec (dllexport) BOOL SetHookHandle (HHOOK);
__declspec (dllexport) BOOL SetWindowHandle (HWND);
__declspec (dllexport) LRESULT CALLBACK ShellProc (int, WPARAM, LPARAM);

BOOL WINAPI DllMain (HINSTANCE, DWORD, LPVOID);

/////////////////////////////////////////////////////////////////////////////
// Shared global data
//
// IMPORTANT: This DLL must be linked with a /SECTION:Shared,RWS switch
// so "Shared" will be a shared data segment

#pragma data_seg ("Shared")
HHOOK   g_hHook = NULL;
HWND    g_hWnd = NULL;
#pragma data_seg ()

/////////////////////////////////////////////////////////////////////////////
// DllMain

BOOL WINAPI DllMain (HINSTANCE hInstance, DWORD dwReason, LPVOID lpvReserved)
{
    return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// Hook procedure

__declspec (dllexport) LRESULT CALLBACK ShellProc (int nCode, WPARAM wParam,
    LPARAM lParam)
{
    char szDir[MAX_PATH];

    if ((nCode == HSHELL_WINDOWCREATED) && (g_hWnd != NULL)) {
        GetCurrentDirectory (sizeof (szDir), szDir);
        PostMessage (g_hWnd, WM_USER, (WPARAM) GlobalAddAtom (szDir),
            (LPARAM) wParam);
    }
    return CallNextHookEx (g_hHook, nCode, wParam, lParam);
}

/////////////////////////////////////////////////////////////////////////////
// Other exported functions

__declspec (dllexport) BOOL SetHookHandle (HHOOK hHook)
{
    if (g_hHook != NULL)
        return FALSE;
    g_hHook = hHook;
    return TRUE;
}

__declspec (dllexport) BOOL SetWindowHandle (HWND hWnd)
{
    if (g_hWnd != NULL)
        return FALSE;
    g_hWnd = hWnd;
    return TRUE;
}
